;# Draw the Game board with no complex graphics 

alias board {
  /window -p +b @xox 230 40 150 250
  ;#Vertical
  /drawline -ihr @xox 4 3 50 50 50 200
  /drawline -ihr @xox 4 3 100 50 100 200
  ;#Horizontal
  /drawline -ihr @xox 4 1 0 48 250 48
  /drawline -ihr @xox 4 3 0 100 250 100
  /drawline -ihr @xox 4 3 0 150 250 150
  /drawline -ihr @xox 4 1 0 202 250 202
  ;#Patch Points
  /drawdot -ihr @xox 4 3 52 102
  /drawdot -ihr @xox 4 3 52 152
  /drawdot -ihr @xox 4 3 102 152
  /drawdot -ihr @xox 4 3 102 102
  ;#Add some Color
  /drawrect -f @xox 8 1 0 203 147 44 
  /drawrect -f @xox 15 1 0 217 147 44
  /drawrect -f @xox 7 1 0 0 150 47
  drawtext -oc @xox 1 Courier 25 15 0 150 47  XOX Board
  drawtext -oc @xox 12 Courier 15 25 20 150 47 by firecool
  drawtext -oc @xox 5 Courier 1 40 35 150 47 v.1.1.2
  drawtext -oc @xox 5 Courier 1 137 235 150 47 X
  drawtext -oc @xox 5 Courier 1 3 235 150 47 -
  drawtext -oc @xox 5 Courier 1 57 235 150 47 HELP
  ;#Reset Variables
  unset %mark.box.*
}

;#All possible combinations of winning cases are included in these if-statements

alias check_if_win {
  if (%mark.box.one == x) && (%mark.box.two == x) && (%mark.box.three == x) { win | halt }
  if (%mark.box.four == x) && (%mark.box.five == x) && (%mark.box.six == x) { win | halt  }
  if (%mark.box.seven == x) && (%mark.box.eight == x) && (%mark.box.nine == x) { win | halt  }
  if (%mark.box.one == x) && (%mark.box.five == x) && (%mark.box.nine == x) { win | halt  }
  if (%mark.box.three == x) && (%mark.box.five == x) && (%mark.box.seven == x) { win | halt  }
  if (%mark.box.one == x) && (%mark.box.four == x) && (%mark.box.seven == x) { win | halt  }
  if (%mark.box.two == x) && (%mark.box.five == x) && (%mark.box.eight == x) { win | halt  }
  if (%mark.box.three == x) && (%mark.box.six == x) && (%mark.box.nine == x) { win  | halt }
  if (%mark.box.one == o) && (%mark.box.two == o) && (%mark.box.three == o) { looser | halt  }
  if (%mark.box.four == o) && (%mark.box.five == o) && (%mark.box.six == o) { looser  | halt  }
  if (%mark.box.seven == o) && (%mark.box.eight == o) && (%mark.box.nine == o) { looser  | halt }
  if (%mark.box.one == o) && (%mark.box.five == o) && (%mark.box.nine == o) { looser | halt }
  if (%mark.box.three == o) && (%mark.box.five == o) && (%mark.box.seven == o) { looser | halt  }
  if (%mark.box.one == o) && (%mark.box.four == o) && (%mark.box.seven == o) { looser | halt  }
  if (%mark.box.two == o) && (%mark.box.five == o) && (%mark.box.eight == o) { looser | halt  }
  if (%mark.box.three == o) && (%mark.box.six == o) && (%mark.box.nine == o) { looser  | halt  }
  if (%mark.box.one != $null) && (%mark.box.two != $null) && (%mark.box.three != $null) && (%mark.box.four != $null) && (%mark.box.five != $null) && (%mark.box.six != $null) && (%mark.box.seven != $null) && (%mark.box.eight != $null) && (%mark.box.nine != $null) { draw }
}

;#Win Case

alias win {
  window -p +b @winner 230 100 150 50
  drawrect -f @winner 6 1 0 0 200 50
  drawtext -oc @winner 8 Courier 15 45 10 150 47 $me
  drawtext -oc @winner 0 Courier 45 30 25 150 47 Wins !!!
  .msg = $+ %xoxplayer 0,0looser
  unset %mark.box.* %myturn %send
  .timer 1 2 /window -c @winner 
  end
}

;# Draw Case

alias draw {
  window -p +b @draw 230 100 150 50
  drawrect -f @draw 12 1 0 0 200 50
  drawtext -oc @draw 0 Courier 45 19 14 150 47 No Winner ! 
  .timer 1 1 .msg = $+ %xoxplayer 0,0draw
  unset %mark.box.* %myturn %send
  .timer 1 2 /window -c @draw 
  end
}

;# Loose case

alias looser {
  window -p +b @looser 230 100 150 50
  drawrect -f @looser 6 1 0 0 200 50
  drawtext -oc @looser 8 Courier 15 45 10 150 47 $me
  drawtext -oc @looser 0 Courier 45 20 25 150 47 Looser :P
  unset %mark.box.* %myturn %send
  .timer 1 2 /window -c @looser 
  end
}

alias mark.box.one {
  if (%mark.box.one != $null) { error | halt }
  set %myturn  false
  drawtext -oc @xox 4 arial 45 13 53 50 50  X
  set %mark.box.one x
  check_if_win
  .msg = $+ %xoxplayer 0,0mark1
  
}
alias mark.box.two {
  if (%mark.box.two != $null) { error | halt }
  set %myturn  false
  drawtext -oc @xox 4 arial 45 63 53 50 50  X
  set %mark.box.two x
  check_if_win
  .msg = $+ %xoxplayer 0,0mark2
}
alias mark.box.three {
  if (%mark.box.three != $null) { error | halt }
  set %myturn  false
  drawtext -oc @xox 4 arial 45 113 53 50 50  X
  set %mark.box.three x
  check_if_win
  .msg = $+ %xoxplayer 0,0mark3
}
alias mark.box.four {
  if (%mark.box.four != $null) { error | halt }
  set %myturn  false
  drawtext -oc @xox 4 arial 45 13 103 50 50  X
  set %mark.box.four x
  check_if_win
  .msg = $+ %xoxplayer 0,0mark4
}
alias mark.box.five {
  if (%mark.box.five != $null) { error | halt }
  set %myturn  false
  drawtext -oc @xox 4 arial 45 63 103 50 50  X
  set %mark.box.five x
  check_if_win
  .msg = $+ %xoxplayer 0,0mark5
}
alias mark.box.six {
  if (%mark.box.six != $null) { error | halt }
  set %myturn  false
  drawtext -oc @xox 4 arial 45 113 103 50 50  X
  set %mark.box.six x
  check_if_win
  .msg = $+ %xoxplayer 0,0mark6
}
alias mark.box.seven {
  if (%mark.box.seven != $null) { error | halt }
  set %myturn false
  drawtext -oc @xox 4 arial 45 13 153 50 50  X
  set %mark.box.seven x
  check_if_win
  .msg = $+ %xoxplayer 0,0mark7
}
alias mark.box.eight {
  if (%mark.box.eight != $null) { error | halt }
  set %myturn  false
  drawtext -oc @xox 4 arial 45 63 153 50 50  X
  set %mark.box.eight x
  check_if_win
  .msg = $+ %xoxplayer 0,0mark8
}
alias mark.box.nine {
  if (%mark.box.nine != $null) { error | halt }
  set %myturn  false
  drawtext -oc @xox 4 arial 45 113 153 50 50  X
  set %mark.box.nine x
  check_if_win
  .msg = $+ %xoxplayer 0,0mark9
}
alias delwait { drawtext -oc @xox 8 Courier 1 0 203 150 47  Please wait ...  }
alias delerror { drawtext -oc @xox 8 Courier 1 10 203 150 47  *** Error *** }
alias wait {  delerror | drawtext -oc @xox 5 Courier 1 0 203 150 47  Please wait ... }
alias error { delwait | drawtext -oc @xox 5 Courier 1 10 203 150 47  *** Error *** | .timer 1 2  delerror }
alias overhelp { delerror | delwait |  drawtext -oc @xox 5 Courier 1 10 203 150 47  Help }
alias overminimize { delerror | delwait |  drawtext -oc @xox 5 Courier 1 10 203 150 47 Minimize Board }
alias overexit { delerror | delwait |  drawtext -oc @xox 5 Courier 1 10 203 150 47 Exit Game }
alias clearall {  delerror | delwait | drawtext -oc @xox 8 Courier 1 10 203 150 47  Help | drawtext -oc @xox 8 Courier 1 10 203 150 47 Minimize Board | drawtext -oc @xox 8 Courier 1 10 203 150 47 Exit Game }
alias finish {   /window -c @xox | .msg = $+ %xoxplayer 0,0finito | .notice %xoxplayer I 've quit the game , You Win !   | unset %mark.box.* %myturn %send %xoxplayer  }
alias end {  /window -c @xox }

menu @xox {
  mouse:  { 
    if ($inrect($mouse.x,$mouse.y,0,48,150,167) == $true) { halt }
    if ($inrect($mouse.x,$mouse.y,0,238,10,10) == $true) { overminimize | halt }  
    if ($inrect($mouse.x,$mouse.y,57,236,40,55) == $true) { overhelp | halt }  
    if ($inrect($mouse.x,$mouse.y,137,235,50,50) == $true) { overexit | halt }  
    if  ($inrect($mouse.x,$mouse.y,0,238,10,10) != $true) || ($inrect($mouse.x,$mouse.y,57,236,40,55) != $true) || ($inrect($mouse.x,$mouse.y,137,235,50,50) == $true) { clearall }
  }
  sclick: {
    if ($inrect($mouse.x,$mouse.y,0,238,10,10) == $true) { /window -n @xox | halt }  
    if ($inrect($mouse.x,$mouse.y,57,236,40,55) == $true) { abouthelp | halt }  
    if ($inrect($mouse.x,$mouse.y,137,235,50,50) == $true) { finish | halt }  
    if (%myturn == false) {
      if ($inrect($mouse.x,$mouse.y,0,48,150,152) == $true) { wait | halt }  
      halt 
    }
    if ($inrect($mouse.x,$mouse.y,0,48,50,50) == $true) { mark.box.one | halt }  
    if ($inrect($mouse.x,$mouse.y,50,48,50,50) == $true) { mark.box.two | halt }  
    if ($inrect($mouse.x,$mouse.y,100,48,50,50) == $true) { mark.box.three | halt }  
    if ($inrect($mouse.x,$mouse.y,0,100,50,50) == $true) { mark.box.four | halt }  
    if ($inrect($mouse.x,$mouse.y,50,100,50,50) == $true) { mark.box.five | halt }  
    if ($inrect($mouse.x,$mouse.y,100,100,50,50) == $true) { mark.box.six | halt }  
    if ($inrect($mouse.x,$mouse.y,0,150,50,50) == $true) { mark.box.seven | halt }  
    if ($inrect($mouse.x,$mouse.y,50,150,50,50) == $true) { mark.box.eight | halt }  
    if ($inrect($mouse.x,$mouse.y,100,150,50,50) == $true) { mark.box.nine | halt }  
  }
}

on 1:CHAT:0,0mark1: { if ($nick == %xoxplayer) { mark1 } }
on 1:CHAT:0,0mark2: { if ($nick == %xoxplayer) { mark2 } }
on 1:CHAT:0,0mark3: { if ($nick == %xoxplayer) { mark3 } }
on 1:CHAT:0,0mark4: { if ($nick == %xoxplayer) { mark4 } }
on 1:CHAT:0,0mark5: { if ($nick == %xoxplayer) { mark5 } }
on 1:CHAT:0,0mark6: { if ($nick == %xoxplayer) { mark6 } }
on 1:CHAT:0,0mark7: { if ($nick == %xoxplayer) { mark7 } }
on 1:CHAT:0,0mark8: { if ($nick == %xoxplayer) { mark8 } }
on 1:CHAT:0,0mark9: { if ($nick == %xoxplayer) { mark9 } }
on 1:CHAT:0,0looser: { if ($nick == %xoxplayer) { looser } }
on 1:CHAT:0,0draw: { if ($nick == %xoxplayer) { if (%mark.box.one == $null) { halt } | draw } }
on 1:CHAT:0,0finito: { if ($nick == %xoxplayer) { unset %mark.box.* %myturn %send %xoxplayer | /window -c @xox } }

alias mark1 {
  drawtext -oc @xox 124 arial  45 13 53 50 50  O
  set %mark.box.one o
  delwait
  check_if_win
  unset %myturn
}
alias mark2 {
  drawtext -oc @xox 124 arial 45 63 53 50 50  O
  set %mark.box.two o
  delwait
  check_if_win
  unset %myturn
}
alias mark3 {
  drawtext -oc @xox 124 arial 45 113 53 50 50  O
  set %mark.box.three o
  delwait
  check_if_win
  unset %myturn
}
alias mark4 {
  drawtext -oc @xox 124 arial 45 13 103 50 50  O
  set %mark.box.four o
  delwait
  check_if_win
  unset %myturn
}
alias mark5 {
  drawtext -oc @xox 124 arial 45 63 103 50 50  O
  set %mark.box.five o
  delwait
  check_if_win
  unset %myturn
}
alias mark6 {
  drawtext -oc @xox 124 arial 45 113 103 50 50  O
  set %mark.box.six o
  delwait
  check_if_win
  unset %myturn
}
alias mark7 {
  drawtext -oc @xox 124 arial 45 13 153 50 50  O
  set %mark.box.seven o
  delwait
  check_if_win
  unset %myturn
}
alias mark8 {
  drawtext -oc @xox 124 arial 45 63 153 50 50  O
  set %mark.box.eight o
  delwait
  check_if_win
  unset %myturn
}
alias mark9 {
  drawtext -oc @xox 124 arial 45 113 153 50 50  O
  set %mark.box.nine o
  delwait
  check_if_win
  unset %myturn
}

ON 1:chat:0,0xoxboard: {
  if (%send == true) { halt }
  if (%enable.xox.on != <=) { .notice $nick Sorry $nick , but I dont want to play XOX right now ..... try later  }
  if (%xoxplayer == $nick) { board |  .msg = $+ $nick 0,0xoxboard | set %send true |  halt }
  if (%xoxplayer == $null) && (%enable.xox.on == <=) { set %xoxplayer $nick | board | .msg = $+ $nick 0,0xoxboard | set %send true | halt   }
}
on 1:NICK: if ($nick == %xoxplayer) { set %xoxplayer $newnick }
on 1:FILESENT:xox.mrc:/msg $nick I have successfully sent you xox.mrc. To install it simply type here 4 /load -rs xox.mrc



menu query {
  XOX Board
  .(1) DCC Connection : /dcc chat $$1
  .(2) Connect To player : { 
    set %xoxplayer $$1 
    if (%xoxplayer == $me) { echo 4*** You cannot play with yourself , load  a clone :P | unset %xoxplayer | halt }  
    if ($chat(%xoxplayer) == $null) { echo 4*** Make sure you are connected with %xoxplayer via a DCC window | halt }
    echo 6*** Connecting .... Please wait
    .msg = $+ %xoxplayer 0,0xoxboard 
    unset %mark.box.* %myturn %send
    set %myturn false
  }
  .-
  .(3) Enable Connection [ %enable.xox.on ] : set %enable.xox.on <= | unset %enable.xox.off | unset %xoxplayer | unset %mark.box.* %myturn %send
  .(4) Disable Connection [ %enable.xox.off ] : set %enable.xox.off <= | unset %enable.xox.on |  set %xoxplayer  busy | unset %mark.box.* %myturn %send
  .-
  .(5) About / Help : /abouthelp
  .(6) Send the Game : /dcc send $$1 xox.mrc
}

menu nicklist {
  XOX Board
  .(1) DCC Connection : /dcc chat $$1
  .(2) Connect To player : { 
    set %xoxplayer $$1 
    if (%xoxplayer == $me) { echo 4*** You cannot play with yourself , load  a clone :P | unset %xoxplayer | halt }  
    if ($chat(%xoxplayer) == $null) { echo 4*** Make sure you are connected with %xoxplayer via a DCC window | halt }
    echo 6*** Connecting .... Please wait
    .msg = $+ %xoxplayer 0,0xoxboard 
    unset %mark.box.* %myturn %send
  }
  .-
  .(3) Enable Connection [ %enable.xox.on ] : set %enable.xox.on <= | unset %enable.xox.off | unset %xoxplayer | unset %mark.box.* %myturn %send
  .(4) Disable Connection [ %enable.xox.off ] : set %enable.xox.off <= | unset %enable.xox.on |  set %xoxplayer  busy | unset %mark.box.* %myturn %send
  .-
  .(5) About / Help : /abouthelp
  .(6) Send the Game : /dcc send $$1 xox.mrc
}


menu channel {
  XOX Board
  .(1) DCC Connection : /dcc chat $$?="Nick to DCC ?"
  .(2) Connect To player : { 
    set %xoxplayer $$?="Nick to play with ?" 
    if (%xoxplayer == $me) { echo 4*** You cannot play with yourself , load  a clone :P | unset %xoxplayer | halt }  
    if ($chat(%xoxplayer) == $null) { echo 4*** Make sure you are connected with %xoxplayer via a DCC window | halt }
    echo 6*** Connecting .... Please wait
    .msg = $+ %xoxplayer 0,0xoxboard 
    unset %mark.box.* %myturn %send
  }
  .-
  .(3) Enable Connection [ %enable.xox.on ] : set %enable.xox.on <= | unset %enable.xox.off | unset %xoxplayer | unset %mark.box.* %myturn %send
  .(4) Disable Connection [ %enable.xox.off ] : set %enable.xox.off <= | unset %enable.xox.on |  set %xoxplayer  busy | unset %mark.box.* %myturn %send
  .-
  .(5) About / Help : /abouthelp
  .(6) Send the Game : /dcc send $$?="Nick to send XOX board ?"  xox.mrc
}

menu status {
  XOX Board
  .(1) DCC Connection : /dcc chat $$?="Nick to DCC ?"
  .(2) Connect To player : { 
    set %xoxplayer $$?="Nick to play with ?" 
    if (%xoxplayer == $me) { echo 4*** You cannot play with yourself , load  a clone :P | unset %xoxplayer | halt }  
    if ($chat(%xoxplayer) == $null) { echo 4*** Make sure you are connected with %xoxplayer via a DCC window | halt }
    echo 6*** Connecting .... Please wait
    .msg = $+ %xoxplayer 0,0xoxboard 
    unset %mark.box.* %myturn %send
  }
  .-
  .(3) Enable Connection [ %enable.xox.on ] : set %enable.xox.on <= | unset %enable.xox.off | unset %xoxplayer | unset %mark.box.* %myturn %send
  .(4) Disable Connection [ %enable.xox.off ] : set %enable.xox.off <= | unset %enable.xox.on |  set %xoxplayer  busy | unset %mark.box.* %myturn %send
  .-
  .(5) About / Help : /abouthelp
  .(6) Send the Game : /dcc send $$?="Nick to send XOX board ?"  xox.mrc
}

menu menubar {
  XOX Board
  .(1) DCC Connection : /dcc chat $$?="Nick to DCC ?"
  .(2) Connect To player : { 
    set %xoxplayer $$?="Nick to play with ?" 
    if (%xoxplayer == $me) { echo 4*** You cannot play with yourself , load  a clone :P | unset %xoxplayer | halt }  
    if ($chat(%xoxplayer) == $null) { echo 4*** Make sure you are connected with %xoxplayer via a DCC window | halt }
    echo 6*** Connecting .... Please wait
    .msg = $+ %xoxplayer 0,0xoxboard 
    unset %mark.box.* %myturn %send
  }
  .-
  .(3) Enable Connection [ %enable.xox.on ] : set %enable.xox.on <= | unset %enable.xox.off | unset %xoxplayer | unset %mark.box.* %myturn %send
  .(4) Disable Connection [ %enable.xox.off ] : set %enable.xox.off <= | unset %enable.xox.on |  set %xoxplayer  busy | unset %mark.box.* %myturn %send
  .-
  .(5) About / Help : /abouthelp
  .(6) Send the Game : /dcc send $$?="Nick to send XOX board ?"  xox.mrc
}

alias abouthelp {
  .window -l +b @XOX-help 200 50 350 372 
  aline  @XOX-help      XOX Board by firecool v1.1.2
  aline  @XOX-help 6 ===========================
  aline  @XOX-help      0$null
  aline  @XOX-help Please feel free to add this game 
  aline  @XOX-help to your mIRC client. (22/8/98)
  aline  @XOX-help      0$null
  aline  @XOX-help For comments, suggestions , questions
  aline  @XOX-help contact me at firecool@geocities.com
  aline  @XOX-help      0$null
  aline  @XOX-help 4Getting Start
  aline  @XOX-help To connect with other players do
  aline  @XOX-help the following.
  aline  @XOX-help 7(1) Select 12Enable Connection     
  aline  @XOX-help 7(2) DCC the other player
  aline  @XOX-help 7(3) Select 12Connect to player 
  aline  @XOX-help Wait a few secs and the XOX Board
  aline  @XOX-help will be appeared on your screen.
  aline  @XOX-help Thats it :)
  aline  @XOX-help      0$null
  aline  @XOX-help 4Trouble Shooting
  aline  @XOX-help DCCs do not work
  aline  @XOX-help Press ALT+E , click on 12Local Info
  aline  @XOX-help and tick the "local host" and the
  aline  @XOX-help "server" options. Disconnect and
  aline  @XOX-help try to reconnect from IRC.
  aline  @XOX-help DCCs are ok , but cannot connect
  aline  @XOX-help to others.  
  aline  @XOX-help Try to disable and then again enable
  aline  @XOX-help the Game Connection.This will refresh
  aline  @XOX-help some variables.
  aline  @XOX-help Cannot send the game to others
  aline  @XOX-help Make sure you have placed the xox.mrc
  aline  @XOX-help file on your mIRC directory and not somewhere
  aline  @XOX-help else.
  aline  @XOX-help help DCCs are ok , but cannot connect
  aline  @XOX-help to others.  
  aline  @XOX-help Try to disable and then again enable
  aline  @XOX-help the Game Connection.This will refresh
  aline  @XOX-help some variables.
  aline  @XOX-help Cannot send the game to others
  aline  @XOX-help Make sure you have placed the xox.mrc
  aline  @XOX-help file on your mIRC directory and not somewhere
  aline  @XOX-help else.
  
  
}
